; 
    include \masm32\include\masm32rt.inc
    .686
; 
    .data
      pcFreq    dq 0
      pcCount1  dq 0
      pcCount2  dq 0
      pcTot     dd 0
      pcMean    dd 0
      hThread   dd 0
      hEvent    dd 0
      fTest     dd 0
      fExit     dd 0
      us        REAL8 0.0
    .code
; 
ThreadProc proc pParam:DWORD
    .WHILE 1
      .IF fTest
        invoke QueryPerformanceCounter, ADDR pcCount2
        mov fTest, 0
        invoke SetEvent, hEvent
      .ELSEIF fExit
        ret
      .ENDIF
    .ENDW
ThreadProc endp
; 
start:
; 
    invoke QueryPerformanceFrequency, ADDR pcFreq

    invoke Sleep, 4000

    invoke CreateThread, 0, 0, ThreadProc, ADDR fExit, 0, 0
    mov hThread, eax

    xor ebx, ebx
    .WHILE ebx < 100

      invoke QueryPerformanceCounter, ADDR pcCount1
      mov fTest, 1

      .WHILE fTest

        ; --------------------------------
        ; Execute until end of time slice.
        ; --------------------------------

        nop

      .ENDW

      mov eax, DWORD PTR pcCount1
      sub DWORD PTR pcCount2, eax
      mov eax, DWORD PTR pcCount1+4
      sbb DWORD PTR pcCount2+4, eax

      mov eax, DWORD PTR pcCount2
      add DWORD PTR pcTot, eax
      mov eax, DWORD PTR pcCount2+4
      add DWORD PTR pcTot+4, eax

      inc ebx
    .ENDW

    fild pcTot
    fild pcFreq
    fdiv                      ; pcTot / pcFreq = seconds
    fld8 100.0
    fdiv                      ; seconds / loopcount = seconds per loop
    fld8 1000000.0
    fmul                      ; seconds per loop * 1000000
    fstp us
    invoke crt_printf,
      chr$("%.0f us, mean waiting for end of time slice%c"), us, 10

    mov pcTot, 0
    mov fTest, 0

    invoke Sleep, 1000

    xor ebx, ebx
    .WHILE ebx < 100

      invoke QueryPerformanceCounter, ADDR pcCount1
      mov fTest, 1

      .WHILE fTest

        ; --------------------------------------------------------
        ; Relinquish remainder of time slice using Sleep function.
        ; --------------------------------------------------------

        invoke Sleep, 0

      .ENDW

      mov eax, DWORD PTR pcCount1
      sub DWORD PTR pcCount2, eax
      mov eax, DWORD PTR pcCount1+4
      sbb DWORD PTR pcCount2+4, eax

      mov eax, DWORD PTR pcCount2
      add DWORD PTR pcTot, eax
      mov eax, DWORD PTR pcCount2+4
      add DWORD PTR pcTot+4, eax

      inc ebx
    .ENDW

    fild pcTot
    fild pcFreq
    fdiv                      ; pcTot / pcFreq = seconds
    fld8 100.0
    fdiv                      ; seconds / loopcount = seconds per loop
    fld8 1000000.0
    fmul                      ; seconds per loop * 1000000
    fstp us
    invoke crt_printf,chr$("%.0f us, mean using Sleep, 0%c"),us,10

    mov pcTot, 0
    mov fTest, 0

    invoke Sleep, 1000

    invoke CreateEvent, 0, 0, 0, 0  ; auto reset, non-signaled
    mov hEvent, eax

    xor ebx, ebx
    .WHILE ebx < 100

      invoke QueryPerformanceCounter, ADDR pcCount1
      mov fTest, 1

      .WHILE fTest

        ; -------------------------------------------------------------
        ; Relinquish remainder of time slice using event wait function.
        ; -------------------------------------------------------------

        invoke WaitForSingleObject, hEvent, 1000

      .ENDW

      mov eax, DWORD PTR pcCount1
      sub DWORD PTR pcCount2, eax
      mov eax, DWORD PTR pcCount1+4
      sbb DWORD PTR pcCount2+4, eax

      mov eax, DWORD PTR pcCount2
      add DWORD PTR pcTot, eax
      mov eax, DWORD PTR pcCount2+4
      add DWORD PTR pcTot+4, eax

      inc ebx
    .ENDW

    fild pcTot
    fild pcFreq
    fdiv                      ; pcTot / pcFreq = seconds
    fld8 100.0
    fdiv                      ; seconds / loopcount = seconds per loop
    fld8 1000000.0
    fmul                      ; seconds per loop * 1000000
    fstp us
    invoke crt_printf, chr$("%.0f us, mean using event wait%c"), us, 10

    inc fExit

    inkey "Press any key to exit..."
    exit
; 
end start
